function value = hart6(x)
%----------------------------------------------------------
% Hartman 6 Test Function for Nonlinear Optimization
%
% Taken from "Towards Global Optimisation 2",edited by L.C.W. Dixon and G.P.
% Szego, North-Holland Publishing Company, 1978. ISBN 0 444 85171 2
%
% 0 <= x1 <= 1                  
% 0 <= x2 <= 1
% 0 <= x3 <= 1
% 0 <= x4 <= 1
% 0 <= x5 <= 1
% 0 <= x6 <= 1
% fmin = -3.32236801141551;
% xmin = [0.20168952;  0.15001069;  0.47687398;  0.27533243;  0.31165162;  0.65730054]
%----------------------------------------------------------

%---------------------------------------------------------%
% http://www4.ncsu.edu/~definkel/research/index.html  
%---------------------------------------------------------%

if size(x,1) == 1
 x = x';
end
a = [10,  0.05,  3,  17;
      3, 10,  3.50,   8;
     17, 17,  1.7, 0.05;
      3.5,  0.1, 10, 10;
      1.7,  8, 17,  0.1;
        8, 14,  8, 14];
p = [0.1312, 0.2329, 0.2348, 0.4047;
     0.1696, 0.4135, 0.1451, 0.8828;
     0.5569, 0.8307, 0.3522, 0.8732;
     0.0124, 0.3736, 0.2883, 0.5743;
     0.8283, 0.1004, 0.3047, 0.1091;
     0.5886, 0.9991, 0.6650, 0.0381];
c = [1.0, 1.2, 3.0, 3.2];
for i=1:4
 d(i) = sum(a(:,i).*(x - p(:,i)).^2);
end
value = -sum(c.*exp(-d)); 
